//#define EMULATOR

#define STATUS_STARTSCREEN 	0x01
#define STATUS_LEVEL1 		0x02
#define STATUS_LEVEL2 		0x03
#define STATUS_LEVELSCREEN 	0x04
#define STATUS_ENGINESCREEN 0x05
#define STATUS_ADJUSTSCREEN 0x06
#define STATUS_GAMEOVERSCREEN 0x07
#define STATUS_LEVEL3 		0x08
#define STATUS_LEVEL4 		0x09
#define STATUS_CREDITS		0x0A

#define GAME_MAGICNUMBER 0x23
#define GAME_THUNDERTAG  0x42
#define GAME_FISHBONETAG 0xFB
#define GAME_FISHBONEV1  0x03

#define FONT_OFFSET 384;


u8 main_pause = 0;
u8 main_cheatActive=0;


void main_setUpSRAM(u8 check)
{
	if(check==1)
	{
		if(mem_getFromSRAM(1)==GAME_THUNDERTAG)
		{
			if(mem_getFromSRAM(2)==GAME_FISHBONETAG)
			{
				if(mem_getFromSRAM(3)==GAME_FISHBONEV1)
				{
					return;
				}
			}
		}
	}
	
	mem_setToSRAM(0, GAME_MAGICNUMBER);
	mem_setToSRAM(1, GAME_THUNDERTAG);
	mem_setToSRAM(2, GAME_FISHBONETAG);
	mem_setToSRAM(3, GAME_FISHBONEV1);
	mem_clearSRAM(4, 8);
}


