#include "credits.h"
//#include "game.h"

//s16 lastObjectCollision = -1;
u8 ce_victimCount = 0;
u8 ce_victims[0] = {};
u8 ce_victims_move_death[0] = {};
u8 ce_victims_swap_death[0] = {};
game_bb ce_victims_bb[0] = {};

u8 ce_enemyCount = 0;
u8 ce_enemies[0] = {};
u8 ce_enemy_swap_kill[0] = {};
game_bb ce_enemy_bb[0] = {};
						 //L, R, T, B	

						 
u16 ce_eventCount = 0;
//u16 ce_eventCount = 40;
game_event ce_events[40] = {{GAME_EVENT_SPAWN, 1,    {CE_OBJ_PLAYER, CE_MOVE_PLAYER_SWIM, CE_SWAP_PLAYER_SWIM, 		   -100,0,100,  100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 100,  {CE_OBJ_PLAYER, CE_MOVE_PLAYER_SWIM, CE_SWAP_PLAYER_SWIM, 			100,0,100,  410,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 200,  {CE_OBJ_VICTIM1, CE_MOVE_VICTIM1_SWIM, CE_SWAP_VICTIM1_SWIM, 		410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 300,  {CE_OBJ_VICTIM1, CE_MOVE_VICTIM1_SWIM, CE_SWAP_VICTIM1_SWIM, 		200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 400,  {CE_OBJ_BIGMAK, CE_MOVE_BIGMAK_SWIM, CE_SWAP_BIGMAK_SWIM,   	   -150,0,30,   0,0,30,    5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 500,  {CE_OBJ_BIGMAK, CE_MOVE_BIGMAK_SWIM, CE_SWAP_BIGMAK_SWIM,   		0,0,30,    -150,0,30,  5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 600,  {CE_OBJ_ENEMY_RM1, CE_MOVE_ENEMY_RM1_SWIM, CE_SWAP_ENEMY_RM1_SWIM,	410,0,140,  200,0,140, 5,1,1, ANI_MOVE_STRAIGHT}},
							{GAME_EVENT_SPAWN, 700,  {CE_OBJ_ENEMY_RM1, CE_MOVE_ENEMY_RM1_SWIM, CE_SWAP_ENEMY_RM1_SWIM,	200,0,140, -100,0,140, 5,1,1, ANI_MOVE_STRAIGHT}},
							{GAME_EVENT_SPAWN, 800,  {CE_OBJ_FLASH1, CE_MOVE_FLASH1_SWIM, CE_SWAP_FLASH1_SWIM, 			200,0,0,    150,0,100, 2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 900,  {CE_OBJ_FLASH1, CE_MOVE_FLASH1_SWIM, CE_SWAP_FLASH1_SWIM, 			150,0,100,  0,0,250,   2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1000, {CE_OBJ_WALRUS1, CE_MOVE_WALRUS1_SWIM, CE_SWAP_WALRUS1_SWIM, 		200,0,0,    150,0,100, 2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1100, {CE_OBJ_WALRUS1, CE_MOVE_WALRUS1_SWIM, CE_SWAP_WALRUS1_SWIM, 		150,0,100,  0,0,250,   2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1200, {CE_OBJ_PLAIN1, CE_MOVE_PLAIN1_SWIM, CE_SWAP_PLAIN1_SWIM, 			410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1300, {CE_OBJ_PLAIN1, CE_MOVE_PLAIN1_SWIM, CE_SWAP_PLAIN1_SWIM, 			200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1401, {CE_OBJ_ENEMY_TOOTH1, CE_MOVE_ENEMY_TOOTH1_SWIM, CE_SWAP_ENEMY_TOOTH1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1500, {CE_OBJ_ENEMY_TOOTH1, CE_MOVE_ENEMY_TOOTH1_SWIM, CE_SWAP_ENEMY_TOOTH1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1600, {CE_OBJ_ENEMY_SWARM1, CE_MOVE_ENEMY_SWARM1_SWIM, CE_SWAP_ENEMY_SWARM1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1800, {CE_OBJ_ENEMY_SWARM1, CE_MOVE_ENEMY_SWARM1_SWIM, CE_SWAP_ENEMY_SWARM1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1900, {CE_OBJ_ENEMY_STAR1, CE_MOVE_ENEMY_STAR1_SWIM, CE_SWAP_ENEMY_STAR1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2000, {CE_OBJ_ENEMY_STAR1, CE_MOVE_ENEMY_STAR1_SWIM, CE_SWAP_ENEMY_STAR1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2101, {CE_OBJ_ENEMY1, CE_MOVE_ENEMY1_SWIM, CE_SWAP_ENEMY1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2200, {CE_OBJ_ENEMY1, CE_MOVE_ENEMY1_SWIM, CE_SWAP_ENEMY1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2300, {CE_OBJ_ENEMY_LF1, CE_MOVE_ENEMY_LF1_SWIM, CE_SWAP_ENEMY_LF1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2400, {CE_OBJ_ENEMY_LF1, CE_MOVE_ENEMY_LF1_SWIM, CE_SWAP_ENEMY_LF1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2500, {CE_OBJ_ENEMY_MI1, CE_MOVE_ENEMY_MI1_SWIM, CE_SWAP_ENEMY_MI1_SWIM, 			200,0,0,    150,0,100, 2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2600, {CE_OBJ_ENEMY_MI1, CE_MOVE_ENEMY_MI1_SWIM, CE_SWAP_ENEMY_MI1_SWIM, 			150,0,100,  0,0,250,   2,1,4, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2700, {CE_OBJ_ENEMY_AL1, CE_MOVE_ENEMY_AL1_SWIM, CE_SWAP_ENEMY_AL1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2800, {CE_OBJ_ENEMY_AL1, CE_MOVE_ENEMY_AL1_SWIM, CE_SWAP_ENEMY_AL1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 2901, {CE_OBJ_VIC_NF, CE_MOVE_VIC_NF_SWIM, CE_SWAP_VIC_NF_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3000, {CE_OBJ_VIC_NF, CE_MOVE_VIC_NF_SWIM, CE_SWAP_VIC_NF_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3100, {CE_OBJ_VIC_SF, CE_MOVE_VIC_SF_SWIM, CE_SWAP_VIC_SF_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3200, {CE_OBJ_VIC_SF, CE_MOVE_VIC_SF_SWIM, CE_SWAP_VIC_SF_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3300, {CE_OBJ_ENEMY_RO1, CE_MOVE_ENEMY_RO1_SWIM, CE_SWAP_ENEMY_RO1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3400, {CE_OBJ_ENEMY_RO1, CE_MOVE_ENEMY_RO1_SWIM, CE_SWAP_ENEMY_RO1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3500, {CE_OBJ_ENEMY_KILL1, CE_MOVE_ENEMY_KILL1_SWIM, CE_SWAP_ENEMY_KILL1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3600, {CE_OBJ_ENEMY_KILL1, CE_MOVE_ENEMY_KILL1_SWIM, CE_SWAP_ENEMY_KILL1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3700, {CE_OBJ_ENEMY_DEAD1, CE_MOVE_ENEMY_DEAD1_SWIM, CE_SWAP_ENEMY_DEAD1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3800, {CE_OBJ_ENEMY_DEAD1, CE_MOVE_ENEMY_DEAD1_SWIM, CE_SWAP_ENEMY_DEAD1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 3900, {CE_OBJ_ENEMY_DO1, CE_MOVE_ENEMY_DO1_SWIM, CE_SWAP_ENEMY_DO1_SWIM,  410,0,100,  200,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 4000, {CE_OBJ_ENEMY_DO1, CE_MOVE_ENEMY_DO1_SWIM, CE_SWAP_ENEMY_DO1_SWIM,  200,0,100, -100,0,100, 5,1,1, ANI_MOVE_STRAIGHT}}, 
							//{GAME_EVENT_END,   4400, {0, 0, 0, 0,0,0,  0,0,0,  0,0,0, 0}},
						};

txt	ce_text_enemies[23] = {	{0,0,0, 100,100,  95,-1,90,  6,4, 50,    110,  "Bubbles"},
					{0,0,0, 100,100, 200,-1,80,  6,4, 250,   310,  "SuShi"},
					{0,0,0, 100,100, 150,-1,70,  6,4, 440,   500,  "BIGMAK"},				//bigmak, Minestorm, Thundra, Vincent the Walrus, Krisse, Hedgetrimmer
					{0,0,0, 100,100, 185,-1,110, 6,4, 650,   710,  "Minestorm"},
					{0,0,0, 100,100, 150,-1,75,  6,4, 835,   900,  "Thundra"},
					{0,0,0, 200,100, 100,-1,75,  6,4, 1030,  1110, "Vincent the Walrus"},	//Tusker
					{0,0,0, 200,100, 195,-1,75,  6,4, 1250,  1310, "Krisse"},
					{0,0,0, 200,100, 180,-1,75,  6,4, 1450,  1510, "Hedgetrimmer"},
					{0,0,0, 200,100, 170,-1,75,  6,4, 1650,  1800, "Ben         Greg"}, 	//The Stevensons,  
					{0,0,0, 200,100, 170,-1,185, 7,3, 1650,  1800, "Matt        Wesley"}, 	//8bitmatt, VBMills,
					{0,0,0, 200,100, 300,-1,130, 8,2, 1650,  1800, "Derek"}, 				//foil_lone_wolf
					{0,0,0, 200,100, 205,-1,75,  6,4, 1950,  2010, "Matej"},				//HorvatM
					{0,0,0, 200,100, 215,-1,75,  6,4, 2150,  2210, "Dor-Si"},
					{0,0,0, 200,100, 215,-1,75,  6,4, 2350,  2410, "dasi"},
					{0,0,0, 200,100, 135,-1,75,  6,4, 2530,  2600, "Morintari"},
					{0,0,0, 200,100, 235,-1,75,  6,4, 2750,  2810, "Amos"},					//RunnerPack
					{0,0,0, 200,100, 190,-1,75,  6,4, 2950,  3010, "BLURP"},
					{0,0,0, 200,100, 160,-1,75,  6,4, 3150,  3210, "RIP VAN FISH"},
					{0,0,0, 200,100, 180,-1,75,  6,4, 3350,  3410, "TORPEDO TED"},
					{0,0,0, 200,100, 170,-1,75,  6,4, 3550,  3610, "PORCU-PUFFER"},
					{0,0,0, 200,100, 180,-1,75,  6,4, 3750,  3810, "FISHBONE"},
					{0,0,0, 200,100, 190,-1,75,  6,4, 3950,  4010, "Dolphin"},
					{0,0,0, 300,200,  95,-1,70,  6,4, 4050,  4350, "THANKS FOR PLAYING FISHBONE"},
				 };
						
/*txt	ce_text_credits[7] = {	{0,0,0, 200,200,  95,-1,70,  6,4, 0,    290,   "     Congratulations      |You have beaten the stage"},
					{0,0,0, 200,200,  88,-1,60,  6,4, 300,  590,   "          CREDITS         ||        Programmer:       |       thunderstruck     ||lead artist and game idea:|     benedikt scheffer  "},
					{0,0,0, 200,200,  88,-1,55,  6,4, 600,  890,   "      Regular STAGEs      ||       Level  design      |       thunderstruck      ||          Sprites         |     benedikt scheffer    ||           Music          |   johann sebastian bach  "},
					{0,0,0, 200,200,  88,-1,55,  6,4, 900,  1190,  "  SUPER FISH WORLD STAGE  ||       Level  design      |       thunderstruck      ||          Sprites         |       Shigefumi Hino     ||           Music          |        Koji Kondo        "},
					{0,0,0, 250,200,  70,-1,60,  6,4, 1200, 1490,  "       Game  Development     |         thunderstruck       ||Development of thunder engine|         thunderstruck       ||Development of GH Midi player|         thunderstruck       "},
					{0,0,0, 200,200,  70,-1,60,  6,4, 1500, 1790,  "       BETA TESTERS       ||       Matej Horvat       |       Christian Radke    |       Benjamin Stevens   |       Wesley Milliner    "},
					{0,0,0, 220,200,  88,-1,60,  6,4, 1800, 2190,  "      SPECIAL THANKS       ||          ELFSCHA          |bigmak for being a nice guy|           DANB            |           DASI            |  THE PLANETVB COMMUNITY   "},
				  };*/
				  
				  txt	ce_text_credits[7] = {	
				    {0,0,0, 200,200,  95,-1,70,  6,4, 0,    290,   "     Congratulations      |You have beaten the stage"},
					{0,0,0, 200,200,  88,-1,60,  6,4, 300,  590,   "CREDITS||Programmer|thunderstruck||lead artist and game idea|benedikt scheffer"},
					{0,0,0, 200,200,  88,-1,55,  6,4, 600,  890,   "Regular STAGEs||Level design|thunderstruck||Sprites|benedikt scheffer||Music|johann sebastian bach"},
					{0,0,0, 200,200,  88,-1,55,  6,4, 900,  1190,  "SUPER FISH WORLD STAGE||Level design|thunderstruck||Sprites|Shigefumi Hino||Music|Koji Kondo"},
					{0,0,0, 250,200,  88,-1,60,  6,4, 1200, 1490,  "Development of thunder-engine|thunderstruck||Development of GH Midi-player|thunderstruck||Development of SU Sound-Engine|Matej Horvat"},
					{0,0,0, 200,200,  88,-1,60,  6,4, 1500, 1790,  "BETA TESTERS||Matej Horvat|Christian Radke|Benjamin Stevens|Wesley Milliner||Music on Engine-Screen|Partners in Rhyme"},
					{0,0,0, 220,200,  88,-1,60,  6,4, 1800, 2190,  "SPECIAL THANKS||ELFSCHA for existing|bigmak for being a nice guy|DANB for the music stuff|DASI for knowing stuff|THE PLANETVB COMMUNITY"},
					};
				  
void ce_startUp()
{
	if(ce_screenLoaded==0)
	{
		txt_frameCount = 0;
		txt_textCount = 7;
		txt_texts = ce_text_credits;
		
		
		game_lastScore = 0;
		game_frameCount = 0;
		game_lastEvent = 0;
		game_frameOfDeath=0;
		
		game_textScore[0] = 'E';
		game_textScore[1] = 'N';
		game_textScore[2] = 'D';
		
		game_player = CE_OBJ_PLAYER;
		game_swap_player_eat = CE_SWAP_PLAYER_SWIM;
		game_swap_player_die = CE_SWAP_PLAYER_SWIM;
		game_move_player_die = CE_MOVE_PLAYER_SWIM;
		
		ce_objects[game_player].x = -100;
		ce_objects[game_player].p = 0;
		ce_objects[game_player].y = 100;
		
		game_victimCount = ce_victimCount;
		game_victims = ce_victims;
		game_victims_move_death = ce_victims_move_death;
		game_victims_swap_death = ce_victims_swap_death;
		game_victims_bb = ce_victims_bb;
		
		game_enemyCount = ce_enemyCount;
		game_enemies = ce_enemies;
		game_enemy_swap_kill = ce_enemy_swap_kill;
		game_enemy_bb = ce_enemy_bb;
		
		game_events = ce_events;
		game_eventCount = ce_eventCount;
		game_SRAM_offset = 12;
		
		game_speed_forward = 0;
		game_speed_back = 0;
		game_speed_up = 0;
		game_speed_down = 0;
		
		WORLD_HEAD((ce_lastScreen+1),WRLD_ON | WRLD_BGMAP | 5);
		WORLD_GSET((ce_lastScreen+1),184,-1,26);
		WORLD_MSET((ce_lastScreen+1),0,0,0);
		WORLD_SIZE((ce_lastScreen+1),24,16);
		vbTextOutS(5, 0, 0, game_textScore);

		
		
	}
}

u8 ce_display(HWORD pad)
{
	
	if(ce_Run==0)
	{
		if(ce_frameCount==2200)
		{
			txt_frameCount = 0;
			txt_textCount = 23;
			txt_texts = ce_text_enemies;
			ce_Run = 1;
			game_eventCount = 40;
			game_frameCount = 0;
			game_lastEvent = 0;
			ce_frameCount = 0;
		}
	}
	else
	{
		
		if(ce_frameCount==1400)
		{
			copymem((void*)CharSeg2, (void*)L4ENEMYCHAR, 8192); 
			copymem((void*)BGMap(2), (void*)L4ENEMYMAP, 8192);
		}
		else if(ce_frameCount==2100)
		{
			copymem((void*)CharSeg2, (void*)L1ENEMYCHAR, 8192); 
			copymem((void*)BGMap(2), (void*)L1ENEMYMAP, 8192);
		}
		else if(ce_frameCount==2900)
		{
			copymem((void*)CharSeg2, (void*)L2ENEMYCHAR, 8192); 
			copymem((void*)BGMap(2), (void*)L2ENEMYMAP, 8192);
		}
		else if(ce_frameCount==4400)
		{
			return STATUS_STARTSCREEN;
		}
		
	}
	
	txt_writeText();
	ce_frameCount++;
	
	return game_display(pad, CE_OBJ_PLAYER, STATUS_CREDITS);
}