#define CE_OBJ_WATER1 0
#define CE_OBJ_WATER2 1
#define CE_OBJ_MNTF1 2
#define CE_OBJ_MNTF2 3
#define CE_OBJ_FENCE1 4
#define CE_OBJ_FENCE2 5
#define CE_OBJ_SCORE 6
#define CE_OBJ_PLAYER 7
#define CE_OBJ_VICTIM1 8
#define CE_OBJ_BIGMAK  9
#define CE_OBJ_PLAIN1  10
#define CE_OBJ_WALRUS1  11
#define CE_OBJ_FLASH1  12
#define CE_OBJ_ENEMY_RM1 13
#define CE_OBJ_ENEMY_TOOTH1 14
#define CE_OBJ_ENEMY_SWARM1 15
#define CE_OBJ_ENEMY_STAR1 	16
#define CE_OBJ_ENEMY1 		17
#define CE_OBJ_ENEMY_LF1 	18
#define CE_OBJ_ENEMY_MI1 	19
#define CE_OBJ_ENEMY_AL1 	20
#define CE_OBJ_ENEMY_RO1 	21
#define CE_OBJ_ENEMY_KILL1 	22
#define CE_OBJ_ENEMY_DEAD1 	23
#define CE_OBJ_ENEMY_DO1 	24
#define CE_OBJ_VIC_NF 		25
#define CE_OBJ_VIC_SF 		26


#define CE_SWAP_PLAYER_SWIM		0
#define CE_SWAP_VICTIM1_SWIM  	4
#define CE_SWAP_BIGMAK_SWIM  	10
#define CE_SWAP_PLAIN1_SWIM  	14
#define CE_SWAP_WALRUS1_SWIM  	18
#define CE_SWAP_FLASH1_SWIM	    22
#define CE_SWAP_ENEMY_RM1_SWIM  24
#define CE_SWAP_ENEMY_TOOTH1_SWIM	25
#define CE_SWAP_ENEMY_SWARM1_SWIM	28
#define CE_SWAP_ENEMY_STAR1_SWIM	30
#define CE_SWAP_ENEMY1_SWIM  		32
#define CE_SWAP_ENEMY_LF1_SWIM  	36
#define CE_SWAP_ENEMY_MI1_SWIM  	38
#define CE_SWAP_ENEMY_AL1_SWIM  	50
#define CE_SWAP_ENEMY_RO1_SWIM 		42
#define CE_SWAP_ENEMY_KILL1_SWIM 	46
#define CE_SWAP_ENEMY_DEAD1_SWIM 	48
#define CE_SWAP_ENEMY_DO1_SWIM 		50
#define CE_SWAP_VIC_NF_SWIM			53
#define CE_SWAP_VIC_SF_SWIM			54

#define CE_MOVE_PLAYER_SWIM  		6
#define CE_MOVE_VICTIM1_SWIM  		7
#define CE_MOVE_BIGMAK_SWIM  		8
#define CE_MOVE_PLAIN1_SWIM  		9
#define CE_MOVE_WALRUS1_SWIM  		10
#define CE_MOVE_FLASH1_SWIM  		11
#define CE_MOVE_ENEMY_RM1_SWIM 		12
#define CE_MOVE_ENEMY_TOOTH1_SWIM 	13
#define CE_MOVE_ENEMY_SWARM1_SWIM 	14
#define CE_MOVE_ENEMY_STAR1_SWIM 	15
#define CE_MOVE_ENEMY1_SWIM  		16
#define CE_MOVE_ENEMY_LF1_SWIM  	17
#define CE_MOVE_ENEMY_MI1_SWIM  	18
#define CE_MOVE_ENEMY_AL1_SWIM  	19
#define CE_MOVE_ENEMY_RO1_SWIM  	20
#define CE_MOVE_ENEMY_KILL1_SWIM  	21
#define CE_MOVE_ENEMY_DEAD1_SWIM  	22
#define CE_MOVE_ENEMY_DO1_SWIM  	23
#define CE_MOVE_VIC_NF_SWIM			24
#define CE_MOVE_VIC_SF_SWIM			25





u16 ce_frameCount = 0;
u16 ce_Run = 0;

u16 ce_screenLoaded = 0;

u16 ce_objectCount = 27;
u16 ce_objectSwapCount = 56;
u16 ce_objectMoveCount = 26;
s8 ce_lastScreen = 0;

object ce_objects[27] = {{ 0,0,0, 400,23, 0,1,201,      0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WATER 1
						{  0,0,0, 400,23, 400,1,201,    0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WATER 2
						{  0,0,120, 425,44, 0,6,90,     0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, 	// FAR MOUNTAIN 1
						{  0,0,120, 425,44, 425,6,90,   0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},  // FAR MOUNTAIN 2
						{  0,0,31,  447,80, 0,4,125,    0, 29,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 	// FENCE 1
						{  0,0,31,  447,80, 447,4,125,  0, 28,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   // FENCE 2
						{  0,0,120, 389,48, 0,0,0,      1,  5,  ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},   	// SCORE
						{  0,0,0, 39,57, 100,0,100,     1, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},  // PLAYER
						{408,0,0, 40,30, 410,0,50,      1, 24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1
						{0,0,0, 140,200, -150,0,30,     2, 23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // enemy big mak
						{0,0,40, 45,45, 410,0,100,      3, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy plain fish 1
						{0,0,280, 44,65, 410,0,100,     0, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy walross 1
						{0,0,360,  60,45, 410,0,100,    0, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy flash fish 1
						{240,0,121, 39,100, 410,0,125,  3, 19,  ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, // enemy real mine 1
						{0,0,260, 72,72, 410,0,100,     2, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy toothfish 1
						{0,0,120, 78,78, 410,0,100,     2, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy swarm 1
						{0,0,0,   55,55, 410,0,100,     2, 16, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy starfish 1
						{0,0,0, 79,61, 410,0,100,  		2, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy shark 1
						{0,0,61, 56,48, 410,0,100,  	2, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy lightfish 1
						{0,0,121, 40,33, 200,0,250,  	2, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy mine fish 1
						{0,0,220, 104,26, 410,0,100,  	2, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy aal 1
						{0,0,280, 48,32, 410,0,100,  	2, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy rocket fish 1
						{0,0,200, 32,32, 410,0,100,  	2, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy deadly fish 1
						{0,0,160, 24,16, 410,0,100,  	2,  9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy dead fish 1
						{0,0,320, 40,16, 410,0,100,  	2,  8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // enemy dolphin 1
						{0,0,0, 24,24, 410,0,100,  		2,  7, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1 (nf)
						{0,0,40, 24,24, 410,0,100,  	2,  6, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // victim 4 (sf)
						};  	
						
movement ce_objectmove[26] = {{-396,1,201, 4,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_WATER1, 1, 400,1,201,1},
							 {-396, 1,201, 4,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_WATER2, 1, 400,1,201,1},
							 {-424,6,90,   1,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_MNTF1,  1, 425,6,90,1},
							 {-424,6,90,   1,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_MNTF2,  1, 425,6,90,1},
							 {-445,4,125,  3,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_FENCE1, 1, 447,4,125,1},
							 {-445,4,125,  3,1,1,0, ANI_MOVE_STRAIGHT,CE_OBJ_FENCE2, 1, 447,4,125,1},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,CE_OBJ_PLAYER, 2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,CE_OBJ_VICTIM1,2, 0,0,0, 0},
							 {0,0,30,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_BIGMAK,        3, -150,0,30,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_PLAIN1,     2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_WALRUS1,    2, 410,0,155,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_FLASH1,     2, 200,0,100,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_RM1, 2, 410,0,125,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_TOOTH1,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_SWARM1,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_STAR1,   2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY1,  		2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_LF1,  	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_MI1,   	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_AL1,   	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_RO1,   	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_KILL1,  	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_DEAD1,  	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_ENEMY_DO1,   	2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_VIC_NF,  		2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,CE_OBJ_VIC_SF,  	 	2, 200,0,100,0},
							};
							 
swap ce_objectswap[56] = {{40,0,0, 0,0,0, 10, 10, 1, CE_OBJ_PLAYER,  ANI_SWAP_SWITCH, 1}, 		//player swim animation
						 {80,0,0, 0,0,0, 10, 10, 0, CE_OBJ_PLAYER,  ANI_SWAP_SWITCH, 2},
						 {120,0,0, 0,0,0, 10, 10, 0, CE_OBJ_PLAYER, ANI_SWAP_SWITCH, 3},
						 {0,0,0, 0,0,0, 10, 10, 0, CE_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {448,0,0, 0,0,0, 20, 20, 0, CE_OBJ_VICTIM1, ANI_SWAP_SWITCH, 5}, 		//victim 1 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, CE_OBJ_VICTIM1, ANI_SWAP_SWITCH, 4},
						 {0,0,200, 0,0,0, 0, 30, 1, CE_OBJ_MNTF1, ANI_SWAP_SWITCH, 7},			//mountain animation 1
						 {0,0,120, 0,0,0, 0, 30, 0, CE_OBJ_MNTF1, ANI_SWAP_SWITCH, 8},
						 {0,0,200, 0,0,0, 0, 30, 1, CE_OBJ_MNTF2, ANI_SWAP_SWITCH, 9},			//mountain animation 2
						 {0,0,120, 0,0,0, 0, 30, 0, CE_OBJ_MNTF2, ANI_SWAP_SWITCH, 6},
						 {160,0,0, 0,0,0, 0, 10, 0, CE_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 11}, 		//big mak swim animation
						 {320,0,0, 0,0,0, 0, 10, 0, CE_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 12},
						 {160,0,0, 0,0,0, 0, 10, 0, CE_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 13},
						 {0,0,0,   0,0,0, 0, 100, 0, CE_OBJ_BIGMAK, ANI_SWAP_SWITCH, 10}, 
						 {48,0,40,   0,0,0, 0, 10, 0, CE_OBJ_PLAIN1, ANI_SWAP_SWITCH, 15}, 		//plain fish 1 swim
						 {96,0,40,   0,0,0, 0, 10, 0, CE_OBJ_PLAIN1, ANI_SWAP_SWITCH, 16}, 		
						 {144,0,40,  0,0,0, 0, 10, 0, CE_OBJ_PLAIN1, ANI_SWAP_SWITCH, 17}, 		
						 {0,0,40,    0,0,0, 0, 10, 0, CE_OBJ_PLAIN1, ANI_SWAP_SWITCH, 14}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, CE_OBJ_WALRUS1, ANI_SWAP_SWITCH, 19},	//walrus 1 swim
						 {96,0,280,  0,0,0,   0, 10, 0, CE_OBJ_WALRUS1, ANI_SWAP_SWITCH,  20}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, CE_OBJ_WALRUS1, ANI_SWAP_SWITCH, 21}, 		
						 {0,0,280,    0,0,0,  0, 10,  0, CE_OBJ_WALRUS1, ANI_SWAP_SWITCH, 18}, 		
						 {80,0,360,   0,0,0, 0, 10, 0, CE_OBJ_FLASH1, ANI_SWAP_SWITCH,    23},	//enemy flash 1 swim
						 {0,0,360,    0,0,0, 0, 10, 0, CE_OBJ_FLASH1, ANI_SWAP_SWITCH,    22},
						 {240,0,121, 0,0,0, 0, 30, 0, CE_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH,  24},  //enemy real mine 1 swim animation 
						 {80,0,260,  0,0,0, 10, 10, 0, CE_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 26},  //enemy toothfish 1 swim
						 {0,0,260,   0,0,0, 10, 10, 0, CE_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 27},  
						 {160,0,260, 0,0,0, 10, 10, 0, CE_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 25},  
						 {80,0,120,  0,0,0, 0, 20, 0, CE_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 29},  //enemy swarm 1 swim
						 {0,0,120,   0,0,0, 0, 20, 0, CE_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 28},  
 						 {80,0,0,   0,0,0, 0, 4, 0, CE_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 31},  //enemy starfish 1 swim 
						 { 0,0,0,   0,0,0, 0, 4, 0, CE_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 30},
						 {80,0,0, 0,0,0, 15, 15, 0, CE_OBJ_ENEMY1, ANI_SWAP_SWITCH,  33}, 		//enemy 1 swim animation 
						 {160,0,0, 0,0,0, 15, 15, 0, CE_OBJ_ENEMY1, ANI_SWAP_SWITCH, 34}, 		
						 {80,0,0, 0,0,0, 15, 15, 0, CE_OBJ_ENEMY1, ANI_SWAP_SWITCH,  35}, 		
						 {0,0,0, 0,0,0,  15, 15, 0, CE_OBJ_ENEMY1, ANI_SWAP_SWITCH,  32},
						 {0,0,61, 0,0,0, 20, 20, 0, CE_OBJ_ENEMY_LF1, ANI_SWAP_SWITCH,  37},		//enemy lf 1 swim animation 
						 {80,0,61, 0,0,0, 20, 20, 0, CE_OBJ_ENEMY_LF1, ANI_SWAP_SWITCH, 36},
						 {0,0,121, 0,0,0,  0, 5, 0, CE_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH,  39},	//enemy mine 1 swim animation 
						 {40,0,121, 0,0,0, 0, 5, 0, CE_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH,  38},  
						 {0,0,220, 0,0,0,  0, 20, 0, CE_OBJ_ENEMY_AL1, ANI_SWAP_SWITCH, 41},	//enemy aal 1 swim animation 
						 {0,0,260, 0,0,0, 0, 20, 0, CE_OBJ_ENEMY_AL1, ANI_SWAP_SWITCH,  40},  
						 {56,0,280, 0,0,0, 0,10, 0, CE_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH,   43}, 		//enemy rocket fish 1 animation 
						 {115,0,280, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 44},
						 {177,0,280, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 45},
						 {0,0,280, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH,   43},
						 {40,0,200, 0,0,0, 0,10, 0, CE_OBJ_ENEMY_KILL1, ANI_SWAP_SWITCH, 47}, 		//enemy deadly fish 1 animation 
						 {0,0,200, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_KILL1, ANI_SWAP_SWITCH, 46},
						 {40,0,160, 0,0,0, 0,10, 0, CE_OBJ_ENEMY_DEAD1, ANI_SWAP_SWITCH, 49}, 		//enemy dead fish 1 animation 
						 {0,0,160, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_DEAD1, ANI_SWAP_SWITCH, 48},
						 {80,0,320, 0,0,0, 0,10, 0, CE_OBJ_ENEMY_DO1, ANI_SWAP_SWITCH,   51}, 		//enemy dolphin fish 1 animation 
						 {0,0,320, 0,0,0,  0,10, 0, CE_OBJ_ENEMY_DO1, ANI_SWAP_SWITCH,   50},
						 {40,0,0, 0,0,0,  0,20, 0, 	CE_OBJ_VIC_NF, ANI_SWAP_SWITCH, 53}, 		//victim 1 swim animation 
						 {0,0,0, 0,0,0, 0,20, 0, 	CE_OBJ_VIC_NF,  ANI_SWAP_SWITCH, 52},
						 {40,0,40, 0,0,0, 20, 20, 0, CE_OBJ_VIC_SF, ANI_SWAP_SWITCH, 55}, 		//victim 4 swim animation 
						 {0,0,40, 0,0,0, 20, 20, 0,  CE_OBJ_VIC_SF, ANI_SWAP_SWITCH, 54},
						};

void ce_reset()
{
	u16 i=0;
	ce_screenLoaded = 0;
	ce_frameCount = 0;
	ce_Run = 0;
	
	for(i=0; i<ce_objectCount; i++)
	{
		ce_objects[i].update = ANI_UPDATE_FULL;
		if(i>7)
		{
			ce_objects[i].active=0;
			ce_objects[i].x=410;
		}
	}
	
	for(i=0; i<ce_objectMoveCount; i++)
	{
		if(i>5)
		{
			ce_objectmove[i].active=0;
		}
	}
	
	for(i=0; i<ce_objectSwapCount; i++)
	{
		if(i>1)
		{
			ce_objectswap[i].active=0;
		}
	}
	ce_objectswap[6].active=1;
	ce_objectswap[8].active=1;
	
	main_pause = 1;
	vbDisplayHide();
}
						 
void ce_setUpScreen()
{
	if(ce_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)L3BGCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)L3BGMAP, 8192);
		
		copymem((void*)CharSeg1, (void*)L1FISHCHAR, 8192); 
		copymem((void*)BGMap(1), (void*)L1FISHMAP, 8192);
		
		copymem((void*)CharSeg2, (void*)L3ENEMYCHAR, 8192); 
		copymem((void*)BGMap(2), (void*)L3ENEMYMAP, 8192);
		
		ani_objectCnt = ce_objectCount;
		ani_objects = ce_objects;
		
		ani_objectMoveCnt = ce_objectMoveCount;
		ani_objectSwapCnt = ce_objectSwapCount;
		ani_objectmove = ce_objectmove;
		ani_objectswap = ce_objectswap;
		ani_lastScreen = ce_lastScreen;
		
		//this is game code and shouldn't be here (fix this!)
		ani_activateObject(CE_OBJ_PLAYER);
		ani_activateSwap(CE_SWAP_PLAYER_SWIM);
		ani_objectswap[CE_SWAP_PLAYER_SWIM].delay = 0;

		mp_playerStop();
		mp_loadSong_inv3v12a();
		mp_playerStart();
		
		ani_swapObjects();
		ani_moveObjects();	
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		ce_screenLoaded = 1;
	}

}