#include "../img/enginemap.h"
#include "../img/enginechar.h"

#define ES_OBJ_ENGINETEXT 0
#define ES_OBJ_BLOCK_1_A 1
#define ES_OBJ_BLOCK_2_A 2
#define ES_OBJ_BLOCK_3_A 3
#define ES_OBJ_BLOCK_4_A 4
#define ES_OBJ_BLOCK_5_A 5
#define ES_OBJ_BLOCK_6_A 6
#define ES_OBJ_BLOCK_1_B 7
#define ES_OBJ_BLOCK_2_B 8
#define ES_OBJ_BLOCK_3_B 9
#define ES_OBJ_BLOCK_4_B 10
#define ES_OBJ_BLOCK_5_B 11
#define ES_OBJ_BLOCK_6_B 12
#define ES_OBJ_BLOCK_1_C 13
#define ES_OBJ_BLOCK_2_C 14
#define ES_OBJ_BLOCK_3_C 15
#define ES_OBJ_BLOCK_4_C 16
#define ES_OBJ_BLOCK_5_C 17
#define ES_OBJ_BLOCK_6_C 18
#define ES_OBJ_BLOCK_1_D 19
#define ES_OBJ_BLOCK_2_D 20
#define ES_OBJ_BLOCK_3_D 21
#define ES_OBJ_BLOCK_4_D 22
#define ES_OBJ_BLOCK_5_D 23
#define ES_OBJ_BLOCK_6_D 24
#define ES_OBJ_BLOCK_1_E 25
#define ES_OBJ_BLOCK_2_E 26
#define ES_OBJ_BLOCK_3_E 27
#define ES_OBJ_BLOCK_4_E 28
#define ES_OBJ_BLOCK_5_E 29
#define ES_OBJ_BLOCK_6_E 30

u16 es_screenLoaded = 0;

u16 es_objectCount = 31;
u16 es_objectSwapCount = 13;
u16 es_objectMoveCount = 91;
u8 es_lastScreen = 0;

object es_objects[31] = {//{  1,0,0, 220,80,   84,0,55, 0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // engine text
						{  1,0,0, 220,80,   410,0,55, 0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // engine text
						//{  55,0,0, 51,35,   28,5,15,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-a
						{  55,0,0, 51,35,   410,5,15,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-a
						{  55,0,0, 51,35,   410,5,15,  0, 29, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 2-a
						{  55,0,0, 51,35,   410,5,15, 0, 28, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 3-a
						{  55,0,0, 51,35,   410,5,15, 0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 4-a
						{  55,0,0, 51,35,   410,5,15, 0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 5-a
						{  55,0,0, 51,35,   410,5,15, 0, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 6-a
						{  55,0,0, 51,35,   410,5,55,  0, 24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-b
						{  55,0,0, 51,35,   410,5,55,  0, 23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 2-b
						{  55,0,0, 51,35,   410,5,55, 0, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 3-b
						{  55,0,0, 51,35,   410,5,55, 0, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 4-b
						{  55,0,0, 51,35,   410,5,55, 0, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 5-b
						{  55,0,0, 51,35,   410,5,55, 0, 19, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 6-b
						{  55,0,0, 51,35,   410,5,95,  0, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-c
						{  55,0,0, 51,35,   410,5,95,  0, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 2-c
						{  55,0,0, 51,35,   410,5,95, 0, 16, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 3-c
						{  55,0,0, 51,35,   410,5,95, 0, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 4-c
						{  55,0,0, 51,35,   410,5,95, 0, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 5-c
						{  55,0,0, 51,35,   410,5,95, 0, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 6-c
						{  55,0,0, 51,35,   410,5,135,  0, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-e
						{  55,0,0, 51,35,   410,5,135,  0, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 2-e
						{  55,0,0, 51,35,   410,5,135, 0, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 3-e
						{  55,0,0, 51,35,   410,5,135, 0, 9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 4-e
						{  55,0,0, 51,35,   410,5,135, 0, 8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 5-e
						{  55,0,0, 51,35,   410,5,135, 0, 7, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 6-e
						{  55,0,0, 51,35,   410,5,175,  0, 6, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 1-f
						{  55,0,0, 51,35,   410,5,175,  0, 5, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 2-f
						{  55,0,0, 51,35,   410,5,175, 0, 4, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 3-f
						{  55,0,0, 51,35,   410,5,175, 0, 3, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 4-f
						{  55,0,0, 51,35,   410,5,175, 0, 2, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 5-f
						{  55,0,0, 51,35,   410,5,175, 0, 1, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // block 6-f
						};  	
						
movement es_objectmove[91] = {
							{28,0,15,  1,1,1, 80, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_A, 3, 0,0,0, 0}, // Block A up
							{83,0,15,  1,1,1, 60, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_A, 3, 0,0,0, 0},
							{138,0,15, 1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_A, 3, 0,0,0, 0},
							{193,0,15, 1,1,1, 50, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_A, 3, 0,0,0, 0},
							{248,0,15, 1,1,1, 70, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_A, 3, 0,0,0, 0},
							{303,0,15, 1,1,1, 100, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_A, 3, 0,0,0, 0},
							{28,5,15,  1,1,1, 230, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_A, 3, 0,0,0, 0}, // Block A down
							{83,5,15,  1,1,1, 240, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_A, 3, 0,0,0, 0},
							{138,5,15, 1,1,1, 220, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_A, 3, 0,0,0, 0},
							{193,5,15, 1,1,1, 250, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_A, 3, 0,0,0, 0},
							{248,5,15, 1,1,1, 210, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_A, 3, 0,0,0, 0},
							{303,5,15, 1,1,1, 260, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_A, 3, 0,0,0, 0},
							{28,0,55,  1,1,1, 60, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_B, 3, 0,0,0, 0},  // Block B up
							{83,0,55,  1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_B, 3, 0,0,0, 0},
							{138,0,55, 1,1,1, 130, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_B, 3, 0,0,0, 0},
							{193,0,55, 1,1,1, 80, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_B, 3, 0,0,0, 0},
							{248,0,55, 1,1,1, 100, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_B, 3, 0,0,0, 0},
							{303,0,55, 1,1,1, 70, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_B, 3, 0,0,0, 0},
							{28,5,55,  1,1,1, 200, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_B, 3, 0,0,0, 0},  // Block B down
							{303,5,55, 1,1,1, 210, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_B, 3, 0,0,0, 0},
							{28,0,95,  1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_C, 3, 0,0,0, 0},  // Block C up
							{83,0,95,  1,1,1, 120, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_C, 3, 0,0,0, 0},
							{138,0,95, 1,1,1, 70, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_C, 3, 0,0,0, 0},
							{193,0,95, 1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_C, 3, 0,0,0, 0},
							{248,0,95, 1,1,1, 100, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_C, 3, 0,0,0, 0},
							{303,0,95, 1,1,1, 60, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_C, 3, 0,0,0, 0},
							{28,5,95,  1,1,1, 205, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_C, 3, 0,0,0, 0},  // Block C down
							{303,5,95, 1,1,1, 230, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_C, 3, 0,0,0, 0},
							{28,0,135,  1,1,1, 120, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_D, 3, 0,0,0, 0},  // Block D up
							{83,0,135,  1,1,1, 60, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_D, 3, 0,0,0, 0},
							{138,0,135, 1,1,1, 100, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_D, 3, 0,0,0, 0},
							{193,0,135, 1,1,1, 80, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_D, 3, 0,0,0, 0},
							{248,0,135, 1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_D, 3, 0,0,0, 0},
							{303,0,135, 1,1,1, 50, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_D, 3, 0,0,0, 0},
							{28,5,135,  1,1,1, 240, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_D, 3, 0,0,0, 0}, // Block D down
							{83,5,135,  1,1,1, 210, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_D, 3, 0,0,0, 0},
							{138,5,135, 1,1,1, 230, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_D, 3, 0,0,0, 0},
							{193,5,135, 1,1,1, 250, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_D, 3, 0,0,0, 0},
							{248,5,135, 1,1,1, 290, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_D, 3, 0,0,0, 0},
							{303,5,135, 1,1,1, 270, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_D, 3, 0,0,0, 0},
							{28,0,175,  1,1,1, 90, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_E, 3, 0,0,0, 0},  // Block E up
							{83,0,175,  1,1,1, 105, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_E, 3, 0,0,0, 0},
							{138,0,175, 1,1,1, 50, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_E, 3, 0,0,0, 0},
							{193,0,175, 1,1,1, 100, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_E, 3, 0,0,0, 0},
							{248,0,175, 1,1,1, 80, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_E, 3, 0,0,0, 0},
							{303,0,175, 1,1,1, 120, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_E, 3, 0,0,0, 0},
							{28,5,175,  1,1,1, 250, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_E, 3, 0,0,0, 0}, // Block E down
							{83,5,175,  1,1,1, 220, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_E, 3, 0,0,0, 0},
							{138,5,175, 1,1,1, 270, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_E, 3, 0,0,0, 0},
							{193,5,175, 1,1,1, 280, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_E, 3, 0,0,0, 0},
							{248,5,175, 1,1,1, 230, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_E, 3, 0,0,0, 0},
							{303,5,175, 1,1,1, 260, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_E, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_2_B, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_3_B, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_4_B, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_5_B, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_2_C, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_3_C, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_4_C, 3, 0,0,0, 0},
							{410,0,0,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_BLOCK_5_C, 3, 0,0,0, 0},
							{84,0,55,   1,1,1, 350,ANI_MOVE_JUMP,    ES_OBJ_ENGINETEXT,3, 0,0,0, 0},
							{28,5,15,  10,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_A, 3, 0,0,0, 0}, // Block A move
							{83,5,15,  10,1,1, 1, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_A, 3, 0,0,0, 0}, 
							{138,5,15,  10,1,1, 2, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_A, 3, 0,0,0, 0}, 
							{193,5,15,  10,1,1, 3, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_A, 3, 0,0,0, 0}, 
							{248,5,15,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_A, 3, 0,0,0, 0}, 
							{303,5,15,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_A, 3, 0,0,0, 0}, 
							{28,5,55,  10,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_B, 3, 0,0,0, 0}, // Block B move
							{83,5,55,  10,1,1, 1, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_B, 3, 0,0,0, 0}, 
							{138,5,55,  10,1,1, 2, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_B, 3, 0,0,0, 0}, 
							{193,5,55,  10,1,1, 3, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_B, 3, 0,0,0, 0}, 
							{248,5,55,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_B, 3, 0,0,0, 0}, 
							{303,5,55,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_B, 3, 0,0,0, 0}, 
							{28,5,95,  10,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_C, 3, 0,0,0, 0}, // Block C move
							{83,5,95,  10,1,1, 1, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_C, 3, 0,0,0, 0}, 
							{138,5,95,  10,1,1, 2, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_C, 3, 0,0,0, 0}, 
							{193,5,95,  10,1,1, 3, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_C, 3, 0,0,0, 0}, 
							{248,5,95,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_C, 3, 0,0,0, 0}, 
							{303,5,95,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_C, 3, 0,0,0, 0}, 
							{28,5,135,  10,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_D, 3, 0,0,0, 0}, // Block D move
							{83,5,135,  10,1,1, 1, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_D, 3, 0,0,0, 0}, 
							{138,5,135,  10,1,1, 2, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_D, 3, 0,0,0, 0}, 
							{193,5,135,  10,1,1, 3, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_D, 3, 0,0,0, 0}, 
							{248,5,135,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_D, 3, 0,0,0, 0}, 
							{303,5,135,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_D, 3, 0,0,0, 0}, 
							{28,5,175,  10,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_1_E, 3, 0,0,0, 0}, // Block E move
							{83,5,175,  10,1,1, 1, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_2_E, 3, 0,0,0, 0}, 
							{138,5,175,  10,1,1, 2, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_3_E, 3, 0,0,0, 0}, 
							{193,5,175,  10,1,1, 3, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_4_E, 3, 0,0,0, 0}, 
							{248,5,175,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_5_E, 3, 0,0,0, 0}, 
							{303,5,175,  10,1,1, 4, ANI_MOVE_STRAIGHT,ES_OBJ_BLOCK_6_E, 3, 0,0,0, 0}, 
							//{0,0,0,1,1,1, 0, ANI_MOVE_STRAIGHT,ES_OBJ_ENGINETEXT, 2, 0,0,0,0},
							}
							;
							 
swap es_objectswap[13] = {
						{1,0,80,    0,0,0, 350, 5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 1},
						{1,0,160,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 2},
						{1,0,240,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 3},
						{1,0,160,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 4},
						{1,0,80,    0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 5},
						{1,0,0,     0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 6},
						{1,0,80,    0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 7},
						{1,0,160,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 8},
						{1,0,240,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 9},
						{241,0,240, 0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 10},
						{241,0,160, 0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 11},
						{241,0,80,  0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 12},
						{241,0,0,   0,0,0, 0,  5, 0, ES_OBJ_ENGINETEXT,  ANI_SWAP_SWITCH, 12},
						};

						 
void es_reset()
{
	u8 i=0;
	es_screenLoaded = 0;
	for(i=0; i<es_objectCount; i++)
	{
		es_objects[i].update = ANI_UPDATE_FULL;
	}
	
	for(i=0; i < 32; i++)
	{
		WORLD_HEAD(i,WRLD_ON | WRLD_BGMAP | 0);
		WORLD_GSET(i,0,0,0);
		WORLD_MSET(i,0,0,0);
		WORLD_SIZE(i,0,0);
	}
	main_pause = 1;
	vbDisplayHide();
}

void es_setUpScreen()
{
	if(es_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)ENGINECHAR, 8192); 
		copymem((void*)BGMap(0), (void*)ENGINEMAP, 8192);
		
		ani_objectCnt = es_objectCount;
		ani_objects = es_objects;
		
		ani_objectMoveCnt = es_objectMoveCount;
		ani_objectSwapCnt = es_objectSwapCount;
		ani_objectmove = es_objectmove;
		ani_objectswap = es_objectswap;
		ani_lastScreen = es_lastScreen;
		
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		es_screenLoaded = 1;
	}

}