#include "level3.h"
#include "events\level3events.h"

//#include "game.h"

//s16 lastObjectCollision = -1;
u8 l3_victimCount = 8;
u8 l3_victims[8] = {L3_OBJ_VICTIM1, L3_OBJ_VICTIM2, L3_OBJ_VICTIM3, L3_OBJ_VICTIM4, L3_OBJ_VICTIM5, L3_OBJ_VICTIM6, L3_OBJ_VICTIM7, L3_OBJ_VICTIM8};
u8 l3_victims_move_death[8] = {L3_MOVE_VICTIM1_DEATH, L3_MOVE_VICTIM2_DEATH, L3_MOVE_VICTIM3_DEATH, L3_MOVE_VICTIM4_DEATH, L3_MOVE_VICTIM5_DEATH, L3_MOVE_VICTIM6_DEATH, L3_MOVE_VICTIM7_DEATH, L3_MOVE_VICTIM8_DEATH};
u8 l3_victims_swap_death[8] = {L3_SWAP_VICTIM1_DEATH, L3_SWAP_VICTIM2_DEATH, L3_SWAP_VICTIM3_DEATH, L3_SWAP_VICTIM4_DEATH, L3_SWAP_VICTIM5_DEATH, L3_SWAP_VICTIM6_DEATH, L3_SWAP_VICTIM7_DEATH, L3_SWAP_VICTIM8_DEATH};
game_bb l3_victims_bb[8] = {{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10},{-5, 20, -30, -10}};

u8 l3_enemyCount = 11;
u8 l3_enemies[11] = {L3_OBJ_BIGMAK, L3_OBJ_PLAIN1, L3_OBJ_PLAIN2, L3_OBJ_PLAIN3, L3_OBJ_WALRUS1, L3_OBJ_WALRUS2, L3_OBJ_WALRUS3, L3_OBJ_FLASH1, L3_OBJ_FLASH2, L3_OBJ_ENEMY_RM1, L3_OBJ_ENEMY_RM2};
u8 l3_enemy_swap_kill[11] = {L3_SWAP_BIGMAK_KILL, L3_SWAP_PLAIN1_KILL, L3_SWAP_PLAIN2_KILL, L3_SWAP_PLAIN3_KILL, L3_SWAP_WALRUS1_KILL, L3_SWAP_WALRUS2_KILL, L3_SWAP_WALRUS3_KILL, L3_SWAP_FLASH1_KILL, L3_SWAP_FLASH2_KILL, L3_SWAP_ENEMY_RM1_KILL, L3_SWAP_ENEMY_RM2_KILL};
game_bb l3_enemy_bb[11] = {{10, 150, 60, 120},{10, 30, -40, 10},{10, 30, -40, 10},{10, 30, -40, 10},{10, 30, -40, 10},{10, 30, -40, 10},{10, 30, -40, 10},{10, 70, -30, 20},{10, 70, -30, 20}, {15, 65, -45, 15}, {15, 65, -45, 15}};
						 //L, R, T, B	

//u16 l3_eventCount = 10;
/*u16 l3_eventCount = 25;
const game_event l3_events[25] = { 
							{GAME_EVENT_SPAWN, 2,   {L3_OBJ_VICTIM1, L3_MOVE_VICTIM1_SWIM, L3_SWAP_VICTIM1_SWIM, 408,0,50, -80,0,50, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 45,  {L3_OBJ_VICTIM2, L3_MOVE_VICTIM2_SWIM, L3_SWAP_VICTIM2_SWIM, 408,0,50, -80,0,50, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 90,  {L3_OBJ_VICTIM3, L3_MOVE_VICTIM3_SWIM, L3_SWAP_VICTIM3_SWIM, 408,0,50, -80,0,50, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 135, {L3_OBJ_VICTIM4, L3_MOVE_VICTIM4_SWIM, L3_SWAP_VICTIM4_SWIM, 408,0,50, -80,0,50, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 200, {L3_OBJ_BIGMAK, L3_MOVE_BIGMAK_SWIM, L3_SWAP_BIGMAK_SWIM,   -150,0,30,    0,0,30,  1,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 225, {L3_OBJ_VICTIM5, L3_MOVE_VICTIM5_SWIM, L3_SWAP_VICTIM5_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 270, {L3_OBJ_VICTIM6, L3_MOVE_VICTIM6_SWIM, L3_SWAP_VICTIM6_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 315, {L3_OBJ_VICTIM7, L3_MOVE_VICTIM7_SWIM, L3_SWAP_VICTIM7_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 360, {L3_OBJ_VICTIM8, L3_MOVE_VICTIM8_SWIM, L3_SWAP_VICTIM8_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 400, {L3_OBJ_ENEMY_RM1, L3_MOVE_ENEMY_RM1_SWIM, L3_SWAP_ENEMY_RM1_SWIM,    410,0,140, -110,0,140,  2,1,1, ANI_MOVE_STRAIGHT}},
							{GAME_EVENT_SPAWN, 450, {L3_OBJ_VICTIM5, L3_MOVE_VICTIM5_SWIM, L3_SWAP_VICTIM5_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 500, {L3_OBJ_ENEMY_RM2, L3_MOVE_ENEMY_RM2_SWIM, L3_SWAP_ENEMY_RM2_SWIM,    410,0,125, -110,0,125,  2,1,1, ANI_MOVE_STRAIGHT}},
							{GAME_EVENT_SPAWN, 650, {L3_OBJ_FLASH1, L3_MOVE_FLASH1_SWIM, L3_SWAP_FLASH1_SWIM, 250,0,0,  150,0,250,  1,1,2, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 651, {L3_OBJ_VICTIM1, L3_MOVE_VICTIM1_SWIM, L3_SWAP_VICTIM1_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 699, {L3_OBJ_VICTIM2, L3_MOVE_VICTIM2_SWIM, L3_SWAP_VICTIM2_SWIM, 408,0,155, -80,0,155, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 700, {L3_OBJ_FLASH2, L3_MOVE_FLASH2_SWIM, L3_SWAP_FLASH2_SWIM, 300,0,0,  200,0,250,  1,1,2, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 800,{L3_OBJ_WALRUS1, L3_MOVE_WALRUS1_SWIM, L3_SWAP_WALRUS1_SWIM, 408,0,50,  -80,0,50,  2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 850,{L3_OBJ_WALRUS2, L3_MOVE_WALRUS2_SWIM, L3_SWAP_WALRUS2_SWIM, 408,0,85,  -80,0,85,  2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 900,{L3_OBJ_WALRUS3, L3_MOVE_WALRUS3_SWIM, L3_SWAP_WALRUS3_SWIM, 408,0,120, -80,0,120, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1000,{L3_OBJ_PLAIN1, L3_MOVE_PLAIN1_SWIM, L3_SWAP_PLAIN1_SWIM, 408,0,50,  -80,0,50,  2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1050,{L3_OBJ_PLAIN2, L3_MOVE_PLAIN2_SWIM, L3_SWAP_PLAIN2_SWIM, 408,0,85,  -80,0,85,  2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1100,{L3_OBJ_PLAIN3, L3_MOVE_PLAIN3_SWIM, L3_SWAP_PLAIN3_SWIM, 408,0,120, -80,0,120, 2,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1201, {L3_OBJ_BIGMAK, L3_MOVE_BIGMAK_SWIM, L3_SWAP_BIGMAK_SWIM,   0,0,30,    -150,0,30,  1,1,1, ANI_MOVE_STRAIGHT}}, 
							{GAME_EVENT_SPAWN, 1250, {L3_OBJ_GOAL, L3_MOVE_GOAL_SWIM, L3_SWAP_GOAL_SWIM,    410,-1,100,  -140,-1,100,  1,1,1, ANI_MOVE_STRAIGHT}},
							{GAME_EVENT_END,   1550, {0, 0, 0, 0,0,0,  0,0,0,  0,0,0, 0}},
						};*/

void l3_startUp()
{
	if(l3_screenLoaded==0)
	{
		game_lastScore = 0;
		game_frameCount = 0;
		game_lastEvent = 0;
		game_frameOfDeath=0;
		
		game_textScore[0] = '0';
		game_textScore[1] = '0';
		game_textScore[2] = '0';
		
		game_player = L3_OBJ_PLAYER;
		game_swap_player_eat = L3_SWAP_PLAYER_EAT;
		game_swap_player_die = L3_SWAP_PLAYER_DEATH;
		game_move_player_die = L3_MOVE_PLAYER_DEATH;
		
		l3_objects[game_player].x = 100;
		l3_objects[game_player].p = 0;
		l3_objects[game_player].y = 100;
		
		game_victims = l3_victims;
		game_victims_move_death = l3_victims_move_death;
		game_victims_swap_death = l3_victims_swap_death;
		game_victims_bb = l3_victims_bb;
		
		game_enemies = l3_enemies;
		game_enemy_swap_kill = l3_enemy_swap_kill;
		game_enemy_bb = l3_enemy_bb;
		
		if(main_cheatActive==0)
		{
			game_enemyCount = l3_enemyCount;
			game_victimCount = l3_victimCount;
		}
		else
		{
			game_enemyCount = 0;
			game_victimCount = 0;
		}
		
		game_events = l3_events;
		game_eventCount = l3_eventCount;
		game_SRAM_offset = 8;
		
		game_speed_forward = 2;
		game_speed_back = 2;
		game_speed_up = 2;
		game_speed_down = 2;
		
		WORLD_HEAD((l3_lastScreen+1),WRLD_ON | WRLD_BGMAP | 5);
		WORLD_GSET((l3_lastScreen+1),184,-1,26);
		WORLD_MSET((l3_lastScreen+1),0,0,0);
		WORLD_SIZE((l3_lastScreen+1),24,16);
		vbTextOutS(5, 0, 0, game_textScore);

		
		
	}
}

u8 l3_display(HWORD pad)
{

	return game_display(pad, L3_OBJ_PLAYER, STATUS_LEVEL3);
}